local name, kreicUI = ...;

_G["kreicUI"] = kreicUI;

--Variables para configurar TRUE OR FALSE , NUMEROS , En caso de error, reinstalar y volver a empezar.
--Pendiente por modificar PlayerPowerBarAlt
--true si quieres fijarlo con el addon, false si quieres fijarlo in-game manual
local playerFrameActivado = true
local playerFrameX = -328
local playerFrameY = -149

--true si quieres fijarlo con el addon, false si quieres fijarlo in-game manual
local targetFrameActivado = true
local targetFrameX = 328
local targetFrameY = -149
local targetBuffsOnTop = true

--true si quieres fijarlo con el addon, false si quieres fijarlo in-game manual
local focusFrameActivado = true
local focusFrameX = -688
local focusFrameY = -199

--Microbotones
local microButtonTopLeft = true

--BarraPrincipal Barra 1
local barraCentralScale = 0.9;
local barraCentralBotones = 6;
local barraCentralX = -105;
local barraCentralY = 340;

--FrameColors
local frameColorsActivado = true;

--BossFrame
local moverBossFrame = true;
local bossFrameX = 570;
local bossFrameY = 115;

--Cast Bar
local mostrarTimerCasteo = true;
local playerCastBarScale = 1;
local playerCastBarX = 0;
local playerCastBarY = -195;

local targetCastBarScale = 1.4;
local targetCastBarX = 0;
local targetCastBarY = -115;

local focusCastBarScale = 1;
--Barra 2
local barra2Scale = 0.9;
local barra2X = -260
local barra2Y = 20
local barra2vertical = false
local barra2columnas = 2 			-- 1 o 2
local barra2Buttons = 12

--Barra 3 Tiene que estar activado en Barras de blizzard
local barra3Scale = 0.9
local barra3X = -260
local barra3Y = 61
local barra3vertical = false
local barra3columnas = 2			-- 1 o 2
local barra3Buttons = 12

--Multibar 
local multibarLeftScale = 0.8
local multibarLeftX = 14
local multibarLeftY = 280
local multibarLeftButtons = 12

local multibarRightScale = 0.8
local multibarRightX = 0
local multibarRightY = 280
local multibarRightButtons = 12
--StanceBar
local stanceBarX = 20
local stanceBarY = -40
local stanceBarUbicacion = "TOPLEFT" 
local stanceBarAnchor = "TOPLEFT"
--PetBar
local PetActionBarFrameScale = 0.8;
local petBarX = -30
local petBarY = -55
local petBarUbicacion = "TOPLEFT"
local petBarAnchor = "LEFT"

--PetFrame
local petFrameActivado = false;
local petFrameX = 0;
local petFrameY = 0;


--Ajustes, en caso de modificar el scaling y que se vea montado un icono sobre otro
local iconSizeBarra2 = 40
local iconSizeBarra3 = 40

local minimapChanges = true

local tooltipX = 0
local tooltipY = 180

local ExtraActionButton1X = -310
local ExtraActionButton1Y = 270

local ZoneAbilityX = -250
local ZoneAbilityY = 270

local DisplayCastTimeOutside = false

local azeriteTracker = true

local PositionAltPowerBarX = 0;
local PositionAltPowerBarY = -18;
local MovePositionAltPowerBar = true;

local systemTracker = true;
local AutoSellGrays = true;
local statusColors = {
	"|cff0CD809",
	"|cffE8DA0F",
	"|cffFF9000",
	"|cffD80909"
}


function kreicUI:UFMover(self, event)

ExtraActionButton1.style:SetAlpha(0)
ExtraActionButton1.style:Hide()

ZoneAbilityFrame.SpellButton.Style:SetAlpha(0)
ZoneAbilityFrame.SpellButton.Style:Hide()

if minimapChanges then
MiniMapWorldMapButton:Hide()
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
Minimap:EnableMouseWheel(true)

Minimap:SetScript('OnMouseWheel', function(self, delta)
    if delta > 0 then
        Minimap_ZoomIn()
    else
        Minimap_ZoomOut()
    end
end)
MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("RIGHT", 3, 20)
MinimapBorderTop:ClearAllPoints()
MinimapBorderTop:SetPoint("LEFT",MinimapCluster,"TOP",-81,-16)
MinimapBorderTop.SetPoint = function() end
MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetPoint("LEFT",MinimapCluster,"TOP",-60,-13)
MinimapZoneTextButton.SetPoint = function() end
MinimapBorderTop:SetWidth(163)
end


if playerFrameActivado then
PlayerFrame:ClearAllPoints();
PlayerFrame:SetPoint("CENTER", UIParent, "CENTER",playerFrameX,playerFrameY);
PlayerFrame:SetUserPlaced(true);
end

if targetFrameActivado then
TargetFrame:ClearAllPoints();
TargetFrame:SetPoint("CENTER", UIParent, "CENTER",targetFrameX,targetFrameY);
TargetFrame:SetUserPlaced(true);
TargetFrameToT:ClearAllPoints();
TargetFrameToT:SetPoint("CENTER", UIParent, "CENTER",targetFrameX-70,targetFrameY-37);
TargetFrameToT:SetUserPlaced(true);
end

if focusFrameActivado then
FocusFrame:ClearAllPoints();
FocusFrame:SetPoint("CENTER", UIParent, "CENTER", focusFrameX,focusFrameY);
FocusFrame:SetUserPlaced(true);
end

if microButtonTopLeft then
MoveMicroButtons("TOPLEFT", UIParent, "TOPLEFT", 0, 0, false);
end

MainMenuBarArtFrame.PageNumber:Hide()
MainMenuBarArtFrame.LeftEndCap:Hide()
MainMenuBarArtFrame.RightEndCap:Hide()
MainMenuBarArtFrameBackground:Hide()
MainMenuBarPerformanceBar:Hide()
ActionBarUpButton:Hide()
ActionBarDownButton:Hide()
MicroButtonAndBagsBar:Hide()
StatusTrackingBarManager:Hide()

for i=1,12 do 
--	_G["ActionButton"..i]:SetParent(MainMenuBar) 

	if i > barraCentralBotones then 
		_G["ActionButton"..i]:SetScale(0.00001);
		_G["ActionButton"..i]:SetAlpha(0);
		_G["ActionButton"..i]:EnableMouse(false);
	else
		_G["ActionButton"..i]:SetScale(barraCentralScale);
	end
	
	_G["MultiBarLeftButton"..i]:SetScale(multibarLeftScale);
	_G["MultiBarRightButton"..i]:SetScale(multibarRightScale);
	_G["MultiBarBottomLeftButton"..i]:ClearAllPoints();
	_G["MultiBarBottomRightButton"..i]:ClearAllPoints();	
	
	if i > barra2Buttons then
		_G["MultiBarBottomLeftButton"..i]:SetScale(0.00001);
		_G["MultiBarBottomLeftButton"..i]:SetAlpha(0);
		_G["MultiBarBottomLeftButton"..i]:EnableMouse(false);
	else
	if barra2vertical then
		if barra2columnas == 2 then
			if i > 6 then
			_G["MultiBarBottomLeftButton"..i]:SetPoint("CENTER",iconSizeBarra2,(i-6)*iconSizeBarra2);	
			else
			_G["MultiBarBottomLeftButton"..i]:SetPoint("CENTER",0,i*iconSizeBarra2);
			end
		else
			_G["MultiBarBottomLeftButton"..i]:SetPoint("CENTER",0,i*iconSizeBarra2);	
		end
	else 
		_G["MultiBarBottomLeftButton"..i]:SetPoint("CENTER",i*iconSizeBarra2,0);
	end
	end
	
	if i > barra3Buttons then
		_G["MultiBarBottomRightButton"..i]:SetScale(0.00001);
		_G["MultiBarBottomRightButton"..i]:SetAlpha(0);
		_G["MultiBarBottomRightButton"..i]:EnableMouse(false);
	else
	if barra3vertical then
		if barra3columnas == 2 then
			if i > 6 then
			_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER",iconSizeBarra3,(i-6)*iconSizeBarra3);	
			else
			_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER",0,i*iconSizeBarra3);	
			end
		else
			_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER",0,i*iconSizeBarra3);	
		end
	else
	_G["MultiBarBottomRightButton"..i]:SetPoint("CENTER",i*iconSizeBarra3,0);
	end
	end
	
	if i > multibarRightButtons then
		_G["MultiBarRightButton"..i]:SetScale(0.00001);
		_G["MultiBarRightButton"..i]:SetAlpha(0);
		_G["MultiBarRightButton"..i]:EnableMouse(false);
	end
	
	if i > multibarLeftButtons then
		_G["MultiBarLeftButton"..i]:SetScale(0.00001);
		_G["MultiBarLeftButton"..i]:SetAlpha(0);
		_G["MultiBarLeftButton"..i]:EnableMouse(false);
	end
	
	
end


MultiBarBottomLeft:SetParent(MainMenuBar) 
MultiBarBottomRight:SetParent(MainMenuBar)

MultiBarBottomLeft:SetScale( barra2Scale );
MultiBarBottomRight:SetScale( barra3Scale );

MultiBarBottomLeft:ClearAllPoints() 
MultiBarBottomLeft:SetPoint("CENTER",UIParent,"BOTTOM",barra2X,barra2Y)
MultiBarBottomLeft.SetPoint = function() end 

MultiBarBottomRight:ClearAllPoints() 
MultiBarBottomRight:SetPoint("CENTER",UIParent,"BOTTOM",barra3X,barra3Y)
MultiBarBottomRight.SetPoint = function() end

ActionButton1:ClearAllPoints()
ActionButton1:SetPoint("CENTER",UIParent,"BOTTOM",barraCentralX,barraCentralY) 
ActionButton1.SetPoint = function() end

MultiBarLeftButton1:ClearAllPoints()
MultiBarLeftButton1:SetPoint("CENTER",multibarLeftX,multibarLeftY) 
MultiBarLeftButton1.SetPoint = function() end

MultiBarRightButton1:ClearAllPoints()
MultiBarRightButton1:SetPoint("CENTER",multibarRightX,multibarRightY) 
MultiBarRightButton1.SetPoint = function() end

MultiBarLeft:SetParent(UIParent) 
MultiBarRight:SetParent(UIParent)

StanceButton1:ClearAllPoints()
StanceButton1:SetPoint(stanceBarAnchor,UIParent,stanceBarUbicacion,stanceBarX,stanceBarY) 
StanceButton1.SetPoint = function() end

PetActionBarFrame:SetScale(PetActionBarFrameScale);
PetActionBarFrame:ClearAllPoints()
PetActionBarFrame:SetPoint(petBarAnchor,UIParent,petBarUbicacion,petBarX,petBarY) 
PetActionBarFrame.SetPoint = function() end

CastingBarFrame:SetScale(playerCastBarScale);
CastingBarFrame:ClearAllPoints();
CastingBarFrame:SetPoint("CENTER",UIParent,"CENTER", playerCastBarX, playerCastBarY);
CastingBarFrame.SetPoint = function() end

TargetFrameSpellBar:SetScale(targetCastBarScale);
TargetFrameSpellBar:ClearAllPoints();
TargetFrameSpellBar:SetPoint("CENTER",UIParent,"CENTER", targetCastBarX, targetCastBarY);
TargetFrameSpellBar.SetPoint = function() end

TargetFrame.buffsOnTop = targetBuffsOnTop;
FocusFrameTextureFrameTexture:SetVertexColor(.5,.5,.5)

ExtraActionButton1:ClearAllPoints()
ExtraActionButton1:SetPoint("CENTER", UIParent, "BOTTOM",ExtraActionButton1X,ExtraActionButton1Y) 
ExtraActionButton1.SetPoint = function() end

ZoneAbilityFrame:ClearAllPoints()
ZoneAbilityFrame:SetPoint("CENTER", UIParent, "BOTTOM",ZoneAbilityX,ZoneAbilityY) 
ZoneAbilityFrame.SetPoint = function() end

--MonkStaggerBar:Hide()



for i=1,NUM_CHAT_WINDOWS do 
_G["ChatFrame"..i.."EditBox"]:SetPoint("TOPLEFT",GeneralDockManager,"TOPLEFT",0,0);
_G["ChatFrame"..i]:SetClampedToScreen(false);
_G["ChatFrame"..i]:ClearAllPoints();
_G["ChatFrame"..i]:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",1,5);
_G["ChatFrame"..i].SetPoint = function() end
_G["ChatFrame"..i]:SetHeight(146);
_G["ChatFrame"..i]:SetWidth(400);
_G["ChatFrame"..i.."ResizeButton"]:Hide();
_G["ChatFrame"..i].ScrollBar:Hide();
_G["ChatFrame"..i].ScrollToBottomButton:Hide(); 
end

ChatFrame1ButtonFrame:Hide()
ChatFrameChannelButton:Hide()
ChatFrameMenuButton:Hide()
QuickJoinToastButton:Hide()
for i=1,8 do
	
	if _G["CompactRaidGroup"..i.."Title"] then
		_G["CompactRaidGroup"..i.."Title"]:Hide()
	end
	
	if _G["CompactRaidGroup"..i] then
	--_G["CompactRaidGroup"..i.."Member1"]:ClearAllPoints();
	local previous = _G["CompactRaidGroup"..i]
	_G["CompactRaidGroup"..i.."Member1"]:SetPoint("TOPLEFT",previous,"TOPLEFT",0,0);
	--_G["CompactRaidGroup"..i.."Member1"].SetPoint = function() end
	orderGroup("CompactRaidGroup"..i)
end	
end

if moverBossFrame then
for i = 1, 5 do
  local f = _G["Boss"..i.."TargetFrame"]
  f:ClearAllPoints()
  f:SetParent(UIParent)
  f:SetScale(1)
  if i == 1 then
	f:ClearAllPoints();
    f:SetPoint("CENTER", UIParent, "CENTER", bossFrameX, bossFrameY)
	f.SetPoint = function() end
  else
    local previous = _G["Boss"..(i-1).."TargetFrame"]
	f:ClearAllPoints();
    f:SetPoint("TOPRIGHT", previous, "BOTTOMRIGHT", 0, 0)
	f.SetPoint = function() end
  end
end
end

--kreicUI:UIParty();

end

function kreicUI:evenMoreSettings()
if minimapChanges then
function GetMinimapShape()
    return 'SQUARE'
end
MinimapBorder:Hide()
Minimap:SetMaskTexture("Interface\\Buttons\\WHITE8X8")

-- Set Map Boarder Texture
MinimapBackdrop:SetBackdrop({
    bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = true, tileSize = 16, edgeSize = 16,
    insets = {left = 3, right = 3, top = 3, bottom = 3}
})
MinimapBackdrop:ClearAllPoints()
MinimapBackdrop:SetBackdropBorderColor(0.75, 0.75, 0.75)
MinimapBackdrop:SetBackdropColor(0.15, 0.15, 0.15, 0.0)
MinimapBackdrop:SetAlpha(1.0)
MinimapBackdrop:SetPoint("TOPLEFT", Minimap, "TOPLEFT", -4, 4)
MinimapBackdrop:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 4, -4)

--  Mail Button Placement
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPLEFT", Minimap, -16, 0)
MiniMapMailFrame:SetScale(1)
MiniMapMailFrame:SetFrameStrata("HIGH")

-- LFG / Battleground Button Placement
QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint("TOPRIGHT", Minimap, 18, -88)
QueueStatusMinimapButton:SetScale(1)
QueueStatusMinimapButton:SetFrameStrata("HIGH")

-- Garrison / Class Order Hall Button Placement
GarrisonLandingPageMinimapButton:ClearAllPoints()
GarrisonLandingPageMinimapButton:SetPoint("TOPRIGHT", Minimap, 24, -36)
GarrisonLandingPageMinimapButton:SetScale(.7)
GarrisonLandingPageMinimapButton:SetFrameStrata("HIGH")

-- Tracking Button Placement
MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("TOPRIGHT", Minimap, 17, -58)
MiniMapTracking:SetScale(1)
MiniMapTracking:SetFrameStrata("HIGH")

-- Help Ticket Button Placement
HelpOpenWebTicketButton:ClearAllPoints()
HelpOpenWebTicketButton:SetPoint("TOPLEFT", Minimap, -18, -48)
HelpOpenWebTicketButton:SetScale(1)
HelpOpenWebTicketButton:SetFrameStrata("HIGH")

-- Instance Difficulty Flag Placement
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("BOTTOMLEFT", Minimap, -21, 0)
MiniMapInstanceDifficulty:SetScale(1)
MiniMapInstanceDifficulty:SetFrameStrata("HIGH")

-- Guild Instance Difficulty Flag Placement
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetPoint("BOTTOMLEFT", Minimap, -20, 0)
GuildInstanceDifficulty:SetScale(1)
GuildInstanceDifficulty:SetFrameStrata("HIGH")

-- Challenge Mode Difficulty Flag Placement
MiniMapChallengeMode:ClearAllPoints()
MiniMapChallengeMode:SetPoint("BOTTOMLEFT", Minimap, -20, 0)
MiniMapChallengeMode:SetScale(1)
MiniMapChallengeMode:SetFrameStrata("HIGH")

-- Calendar Button Placement
GameTimeFrame:ClearAllPoints()
GameTimeFrame:SetPoint("TOPRIGHT", Minimap, 22, 0)
GameTimeFrame:SetScale(.75)
GameTimeFrame:SetFrameStrata("HIGH")


end
end

function kreicUI:moreSettings()

if petFrameActivado then
PetFrame:ClearAllPoints();
PetFrame:SetPoint("CENTER", UIParent, "BOTTOM",petFrameX,petFrameY);
PetFrame.SetPoint = function() end
end

--Lua has problems with a lot of variables so 2 functions instead of 1
FocusFrameSpellBar:SetScale(focusCastBarScale);
if frameColorsActivado then
PlayerFrameTexture:SetVertexColor(.5,.5,.5);
PlayerFrameHealthBar:SetHeight(29);
PlayerFrameHealthBar:ClearAllPoints();
PlayerFrameHealthBar:SetPoint("RIGHT", -7, 11);
PlayerFrameHealthBar.SetPoint = function() end
PlayerFrameHealthBar:SetFrameLevel(2);
PlayerFrameBackground:Hide();

TargetFrameTextureFrameTexture:SetVertexColor(.5,.5,.5);
TargetFrameBackground:Hide();
TargetFrameNameBackground:SetAlpha(0);
TargetFrameNameBackground:SetScale(0.00001);

--TargetFrameBackground:Hide();
TargetFrameHealthBar:SetHeight(29)
TargetFrameHealthBar:ClearAllPoints();
TargetFrameHealthBar:SetPoint("LEFT", 7, 11);
TargetFrameHealthBar.SetPoint = function() end

FocusFrameHealthBar:SetHeight(29);
FocusFrameNameBackground:SetAlpha(0);
FocusFrameNameBackground:SetScale(0.00001);
FocusFrameHealthBar:ClearAllPoints();
FocusFrameHealthBar:SetPoint("LEFT", 4, 11);
FocusFrameHealthBar.SetPoint = function() end
end

if mostrarTimerCasteo and DisplayCastTimeOutside then
CastingBarFrame.textBar = CastingBarFrame:CreateFontString("textBar", "OVERLAY", "GameFontHighlight")
CastingBarFrame.textBar:ClearAllPoints()
CastingBarFrame.textBar:SetPoint("CENTER", CastingBarFrame, "RIGHT", 25,5)
CastingBarFrame.textBar.SetPoint = function() end

TargetFrameSpellBar.textBar = TargetFrameSpellBar:CreateFontString("textBar", "OVERLAY", "GameFontHighlight")
TargetFrameSpellBar.textBar:ClearAllPoints()
TargetFrameSpellBar.textBar:SetPoint("CENTER", TargetFrameSpellBar, "RIGHT", 20,0)
TargetFrameSpellBar.textBar.SetPoint = function() end

FocusFrameSpellBar.textBar = FocusFrameSpellBar:CreateFontString("textBar", "OVERLAY", "GameFontHighlight")
FocusFrameSpellBar.textBar:ClearAllPoints()
FocusFrameSpellBar.textBar:SetPoint("CENTER", FocusFrameSpellBar, "RIGHT", 25,0)
FocusFrameSpellBar.textBar.SetPoint = function() end
end

if azeriteTracker then
MainMenuMicroButton.azeriteTrack = MainMenuMicroButton:CreateFontString("azeriteTrack", "OVERLAY", "GameFontHighlight")
MainMenuMicroButton.azeriteTrack:ClearAllPoints()
MainMenuMicroButton.azeriteTrack:SetPoint("LEFT", MainMenuMicroButton, "RIGHT", 0, 8)
MainMenuMicroButton.azeriteTrack.SetPoint = function() end

local azeriteItemLocation = nil;
azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem();
local currentNeckLevel, azeriteXP, azeriteTotalXP, azeritePercentage, azeriteRemaining;
if azeriteItemLocation then 
	currentNeckLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation) or 0;
	azeriteXP, azeriteTotalXP = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation);
	azeritePercentage = math.floor((azeriteXP * 100)/azeriteTotalXP)
	azeriteRemaining = (azeriteTotalXP - azeriteXP)
	MainMenuMicroButton.azeriteTrack:SetText("Lvl:"..currentNeckLevel.." "..azeritePercentage.."% "..azeriteRemaining)
else 
	MainMenuMicroButton.azeriteTrack:SetText("No se detecto Neck")
end
end

if systemTracker then
MainMenuMicroButton.systemTrack = MainMenuMicroButton:CreateFontString("systemTrack", "OVERLAY", "GameFontHighlight")
MainMenuMicroButton.systemTrack:ClearAllPoints()
MainMenuMicroButton.systemTrack:SetPoint("LEFT", MainMenuMicroButton, "RIGHT", 0, -7)
MainMenuMicroButton.systemTrack.SetPoint = function() end
end

--------------------------------------------------------------------------------------------------------------
-- ChatCopy, LUA from ChatCopy Addon. and Link Copy from ChatCopyPaste
-- create widgets and variables
local editFrame = CreateFrame("ScrollFrame", "CopiedChatContent", UIParent, "InputScrollFrameTemplate")

local editBox = editFrame.EditBox
local btnClose = CreateFrame("Button", "ChatCopy", editFrame, "UIPanelButtonTemplate")
local escapes = {
	["|T.-|t"] = "", -- textures
	["{.-}"] = "", -- raid target icons
}

-- functions
local function CloseEditor()
	editBox:SetText("")
	editBox:ClearFocus()
	editFrame:Hide()
end

local function unescape(str)
	-- removes escape sequences which lead to bigger lines
	for k, v in pairs(escapes) do
		str = gsub(str, k, v)
	end
	return str
end

-- setup edit box
editFrame:Hide()
editFrame:SetToplevel(true)
editFrame:SetMovable(true)
editFrame:EnableMouse(true)
tinsert(UISpecialFrames, "editFrame")
editFrame:SetPoint("CENTER", UIParent, -100, 100)
editFrame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",insets = {top = 0, left = 0, bottom = 0, right = 0}})
editFrame:SetBackdropColor(0,0,0,.5)
editFrame.CharCount:Hide()
editFrame:SetFrameLevel(129)
editFrame:SetFrameStrata("FULLSCREEN")

--editBox:SetFontObject("ChatFontNormal")
editBox:SetFont("Fonts\\ARIALN.ttf", 13)
editBox:SetText("")
editBox:SetWidth(editFrame:GetWidth() - 30) -- multiline editboxes need a width declared!!
editBox:SetScript("OnEscapePressed", function(self)
	CloseEditor()
end)
editBox:SetAllPoints()
editFrame:Hide()

-- setup edit box closing button
btnClose:SetPoint("TOPRIGHT")
btnClose:SetSize(15, 15)
btnClose:SetText("x")
btnClose:SetFrameStrata("TOOLTIP")
btnClose:SetScript("OnClick", function(self)
	CloseEditor()
end)

-- copy button in the chat window
function CreateCopyBtnForChat(chatFrame, url)
	if (url) then
		editBox:Insert(url)
		editFrame:SetSize(300, 45)
		editBox:HighlightText()
		editBox:SetWidth(editFrame:GetWidth() - 30)
		editFrame:Show()
		editBox:SetFocus()
	else
		local btnCopy = CreateFrame("Button", "ChatCopy", chatFrame, "UIPanelButtonTemplate")
		btnCopy:SetPoint("TOPRIGHT")
		btnCopy:SetSize(50, 20)
		btnCopy:SetText("Copy")
		btnCopy:SetScript("OnClick", function(self)
			-- gets all chat messages and copies them to the edit box
			editFrame:SetSize(500, 300)
			for iMsg = 1,chatFrame:GetNumMessages() do
				editBox:Insert(unescape(chatFrame:GetMessageInfo(iMsg)))
				editBox:Insert("\n")
			end
			editFrame:Show()
			editBox:HighlightText()
			editBox:SetFocus()
			self:Hide()
		end)
		btnCopy:Hide()
		btnCopy:SetScript("OnEnter", function(self) self:Show() end)
		btnCopy:SetScript("OnLeave", function(self) self:Hide() end)
		chatFrame:SetScript("OnEnter", function(self) btnCopy:Show() end)
		chatFrame:SetScript("OnLeave", function(self) btnCopy:Hide() end)
	end
	-- make it less annoying
end

-- create copy button for all tabs
for i=1,NUM_CHAT_WINDOWS do
	CreateCopyBtnForChat(_G['ChatFrame'..i])
end
end

function ccpChatWebLinks(self, event, msg, author, ...)
	--Sort the domain list from longest to shortest so it matches longest first.
	--table.sort(CCP.ccpChatWebLinksMatches, function(a,b) return #a>#b end)
	--This loop lags the wow client for a second so it's disabled, better to have more false links than lag
	--The domain array is huge and for some reason ChatFrame_AddMessageEventFilter calls this 10 times for 1 chat line sometimes
	--One day I may cleanup the domain list and add a throddle for the chat event filter so leaving it here commented out.
	--for i ,v in pairs(CCP.ccpChatWebLinksMatches) do
		local pattern = "(([%w_.~!*:@&+$/?%%#-]-)(%w[-.%w]*%w%.)(%a)(%a+)(:?)(%d*)(/?)([%w_.~!*:@&+$/?%%#=-]*))"
		local match = string.match(msg, pattern)
		if (match) then
			local replace = " |cff0645AD(|HccpCustomLink:url|h" .. match .. "|h)|r "
			msg = string.gsub(msg, pattern, replace)
			--Just matching 1 url per chat line for now.
			return false, msg, author, ...
		end
	--end
	return false, msg, author, ...
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", ccpChatWebLinks)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", ccpChatWebLinks)

hooksecurefunc("ChatFrame_OnHyperlinkShow", function(...)
	chatFrame, link, text, button = ...
    if (link == "ccpCustomLink:url") then
		createUrlLinkFrame(chatFrame, link, text, button)
	end
end)

local OriginalSetHyperlink = ItemRefTooltip.SetHyperlink
function ItemRefTooltip:SetHyperlink(link, ...)
	if (link and link:sub(0, 13) == "ccpCustomLink") then
		return
	end
	return OriginalSetHyperlink(self, link, ...)
end

function createUrlLinkFrame(chatFrame, link, text, button)
	CreateCopyBtnForChat(1, text)
end
--------------------------------------------------------------------------------------------------------------


CastingBarTimer_DisplayString = " (%0.1fs)";

function KreicModifiedCastBar_OnUpdate( self, ... )
	local timerValue	= self.maxValue - self.value;
	local textDisplay	= self.Text
	if DisplayCastTimeOutside then
	local textDisplayBar = self.textBar
	end
	local _, text, displayName;

	if ( self.casting ) then
		text = UnitCastingInfo(self.unit);
	elseif ( self.channeling ) then
		text = UnitChannelInfo(self.unit);
		timerValue = self.value;
	end

	if ( text ) then
		displayName = text..CastingBarTimer_DisplayString;
	end

	if (displayName ~= nil) then
		if (timerValue) then
			if (timerValue > 0.01) then
				textDisplay:SetText( format(displayName, timerValue) );
				if DisplayCastTimeOutside then
				textDisplayBar:SetText(format(CastingBarTimer_DisplayString, timerValue));
				end
			end
		end
	end
end

if mostrarTimerCasteo then
CastingBarFrame:HookScript("OnUpdate", KreicModifiedCastBar_OnUpdate);
TargetFrameSpellBar:HookScript("OnUpdate", KreicModifiedCastBar_OnUpdate);
FocusFrameSpellBar:HookScript("OnUpdate", KreicModifiedCastBar_OnUpdate);
end

local events = CreateFrame('Frame')
events:RegisterEvent('PLAYER_LOGIN')
events:RegisterEvent("AZERITE_ITEM_EXPERIENCE_CHANGED");
events:RegisterEvent('MERCHANT_SHOW');
--events:RegisterEvent("GROUP_ROSTER_UPDATE")
--events:RegisterEvent("GROUP_JOINED");
--events:RegisterEvent("INSTANCE_GROUP_SIZE_CHANGED");
--events:RegisterEvent("RAID_ROSTER_UPDATE");
--events:RegisterEvent("UNIT_EXITED_VEHICLE");
--events:RegisterEvent("PLAY_MOVIE");
--events:RegisterEvent("READY_CHECK");
events:RegisterEvent("PLAYER_ENTERING_WORLD");
events:RegisterEvent("PLAYER_REGEN_DISABLED");



events:SetScript("OnEvent", function(self, ...)
	local event, arg1 = ...;
	if (event == "PLAYER_LOGIN") then
	-- or event == "PLAYER_ENTERING_WORLD"
			events:UnregisterEvent('PLAYER_LOGIN')
			kreicUI:UFMover();
			kreicUI:moreSettings();
			kreicUI:evenMoreSettings();
			if MovePositionAltPowerBar then
			kreicUI:PositionAltPowerBar();
			end
			if systemTracker then
			FPSMSDisplay();
			end
		end
		
--	if (event == "UNIT_EXITED_VEHICLE" or event == "PLAYER_ENTERING_WORLD") then
--		kreicUI:FixingVehicle_Leave();
--	end
	if (event == "PLAYER_REGEN_DISABLED") then
		local inInstance, instanceType = IsInInstance()
		if inInstance and instanceType == "raid" then
			if ( ObjectiveTrackerFrame.collapsed ) then
				return
			else
				ObjectiveTracker_Collapse();
			end
		end
	end
	
--	if (event == "GROUP_ROSTER_UPDATE" or event == "GROUP_JOINED" or event == "INSTANCE_GROUP_SIZE_CHANGED" or event == "PLAYER_ENTERING_WORLD" or event == "RAID_ROSTER_UPDATE" or event == "READY_CHECK") then
--		local inCombat = InCombatLockdown()
--		if not inCombat then
--			kreicUI:UIParty(self.unit);
--		end
--	end
	
if azeriteTracker then	
	if (event == "AZERITE_ITEM_EXPERIENCE_CHANGED") then
		kreicUI:UpdateAzeriteExp();
	end	
end

if AutoSellGrays then
	if (event == "MERCHANT_SHOW") then
		kreicUI:AutoSellGrays();
	end
end

end)

--function kreicUI:FixingVehicle_Leave()
--	MoveMicroButtons("TOPLEFT", UIParent, "TOPLEFT", 0, 0, false);
--end

function kreicUI:AutoSellGrays()
local c,i,n,v=0;
for b=0,4 do 
	for s=1,GetContainerNumSlots(b)do 
		i={GetContainerItemInfo(b,s)}
		n=i[7]
		if n and string.find(n,"9d9d9d")then 
		v={GetItemInfo(n)}q=i[2]c=c+v[11]*q;
		UseContainerItem(b,s)
		print(n,q) end;
	end;
end;
print(GetCoinText(c))
end

function FPSMSDisplay()
local framerate = math.floor(GetFramerate())
local _,_,_,latency = GetNetStats()
MainMenuMicroButton.systemTrack:SetFormattedText("FPS:%s%d|r MS:%s%d|r",
			statusColors[framerate >= 30 and 1 or (framerate >= 20 and framerate < 30) and 2 or (framerate >= 10 and framerate < 20) and 3 or 4],
			framerate,
			statusColors[latency < 150 and 1 or (latency >= 150 and latency < 300) and 2 or (latency >= 300 and latency < 500) and 3 or 4],
			latency)
			C_Timer.After(3, FPSMSDisplay)
end


function kreicUI:UpdateAzeriteExp()
local azeriteItemLocation = nil;
azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem();
local currentNeckLevel, azeriteXP, azeriteTotalXP, azeritePercentage, azeriteRemaining;
if azeriteItemLocation then 
	currentNeckLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation) or 0;
	azeriteXP, azeriteTotalXP = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation);
	azeritePercentage = math.floor((azeriteXP * 100)/azeriteTotalXP)
	azeriteRemaining = (azeriteTotalXP - azeriteXP)
	MainMenuMicroButton.azeriteTrack:SetText("Lvl:"..currentNeckLevel.." "..azeritePercentage.."% "..azeriteRemaining)
end
end

if frameColorsActivado then
hooksecurefunc("UnitFrameHealthBar_Update", function(self,...)
	if self.unit then
		colour(self, self.unit)
	end
end)

hooksecurefunc("HealthBar_OnValueChanged", function(self,...)
	if self.unit then
		colour(self, self.unit)
	end
end)
end

hooksecurefunc("MoveMicroButtons", function(self,...)
	CharacterMicroButton:ClearAllPoints();
	CharacterMicroButton:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0);
	LFDMicroButton:ClearAllPoints();
	LFDMicroButton:SetPoint("BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", -2, 0);
	MainMenuMicroButton_RepositionAlerts();
	UpdateMicroButtons();
end)

function colour(self,unit)

local UIP=UnitIsPlayer 
local RCC=RAID_CLASS_COLORS 
local UIC=UnitIsConnected
local UC=UnitClass 
local TFNB=TargetFrameNameBackground 
local FFNB=FocusFrameNameBackground
local PFHB=PlayerFrameHealthBar 
local TFHB=TargetFrameHealthBar
local FFHB=FocusFrameHealthBar

if unit == "target" then
	if UIP(unit) then
		local c=RCC[select(2,UC("target"))] 
		TFHB:SetStatusBarColor(c.r,c.g,c.b)
		if TFNB then 
		TFNB:Hide()
	end
	elseif UnitIsEnemy("player",unit) then
		TFHB:SetStatusBarColor(0.8,0,0) 
		if TFNB then
		TFNB:Hide()
		end
	end
end

if unit == "player" and UIC then
	local _,cl=UC("player") 
	local c=RAID_CLASS_COLORS[cl] 
	PFHB:SetStatusBarColor(c.r,c.g,c.b) 
end

if unit == "focus" and UIP(unit) then
	local c=RCC[select(2,UC("focus"))] 
	FFHB:SetStatusBarColor(c.r,c.g,c.b)
	end
end

function kreicUI:UIParty(frame)

for i=1,8 do
	
	if _G["CompactRaidGroup"..i.."Title"] then
		_G["CompactRaidGroup"..i.."Title"]:Hide()
	end
	
	if _G["CompactRaidGroup"..i] then
	--_G["CompactRaidGroup"..i.."Member1"]:ClearAllPoints();
	local group = _G["CompactRaidGroup"..i]
	_G["CompactRaidGroup"..i.."Member1"]:SetPoint("TOPLEFT",group,"TOPLEFT",0,0);
	orderGroup("CompactRaidGroup"..i)
	end
	
end

end

function orderGroup(frame)
	local totalHeight = 0;
	local totalWidth = 0;
	for i=2, MEMBERS_PER_RAID_GROUP do
				local unitFrame = _G[frame.."Member"..i];
				--unitFrame:ClearAllPoints();
				unitFrame:SetPoint("LEFT", _G[frame.."Member"..(i-1)], "RIGHT", 0, 0);
end

totalHeight = totalHeight + _G[frame.."Member1"]:GetHeight();
totalWidth = totalWidth + _G[frame.."Member1"]:GetWidth() * MEMBERS_PER_RAID_GROUP;
local f = _G[frame]
if ( f.borderFrame:IsShown() ) then
		totalWidth = totalWidth + 12;
		totalHeight = totalHeight + 4;
end

f:SetSize(totalWidth, totalHeight);


end
	
local function setPoint(self)
	local scale = self:GetEffectiveScale()
	--local x, y = GetCursorPosition()
	self:ClearAllPoints()
	self:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", tooltipX, tooltipY)
end

hooksecurefunc("GameTooltip_SetDefaultAnchor", function(tooltip, parent)
	tooltip:SetOwner(parent, "ANCHOR_NONE")
	setPoint(tooltip)
	tooltip.default = 1
end)

function kreicUI:PositionAltPowerBar()
	local holder = CreateFrame('Frame', 'AltPowerBarHolder', UIParent)
	holder:SetPoint('TOP', UIParent, 'TOP', PositionAltPowerBarX, PositionAltPowerBarY)
	holder:SetSize(128, 50)

	PlayerPowerBarAlt:ClearAllPoints()
	PlayerPowerBarAlt:SetPoint('CENTER', holder, 'CENTER')
	PlayerPowerBarAlt:SetParent(holder)
	PlayerPowerBarAlt.ignoreFramePositionManager = true

	local function Position(self)
		self:SetPoint('CENTER', AltPowerBarHolder, 'CENTER')
	end
	hooksecurefunc(PlayerPowerBarAlt, "ClearAllPoints", Position)

end